package org.kantega.jexmec.spring;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.ListableBeanFactory;
import org.springframework.beans.factory.config.AbstractFactoryBean;

/*
 * Copyright 2011 Kantega AS
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *
 */
public class SpringServiceLocatorFactoryBean extends AbstractFactoryBean {
    private Class servicesClass;

    @Override
    public Class<?> getObjectType() {
        return SpringServiceLocator.class;
    }

    @Override
    protected Object createInstance() throws Exception {
        if(servicesClass == null) {
            throw new BeanCreationException("You must specify a servicesClass");
        }
        return new SpringServiceLocator((ListableBeanFactory) getBeanFactory(), servicesClass);
    }

    public void setServicesClass(Class servicesClass) {
        this.servicesClass = servicesClass;
    }
}
